import { FieldConfigMetadata } from '@aws-amplify/codegen-ui/lib/types';
import { VariableStatement, ExpressionStatement, Statement } from 'typescript';
export declare const buildDataStoreExpression: (dataStoreActionType: 'update' | 'create', importedModelName: string, hasManyFieldConfigs: [string, FieldConfigMetadata][]) => (ExpressionStatement | VariableStatement)[];
/**
  example: const validationResponses = await Promise.all(
    Object.keys(validations).reduce((promises, fieldName) => {
      if (Array.isArray(modelFields[fieldName])) {
        promises.push(
          ...modelFields[fieldName].map((item) =>
            runValidationTasks(fieldName, item, getDisplayValue[fieldName]),
          ),
        );
        return promises;
      }
      promises.push(runValidationTasks(fieldName, modelFields[fieldName], getDisplayValue[fieldName]));
      return promises;
    }, []),
  );
  if (validationResponses.some((r) => r.hasError)) {
    return;
  }
*/
export declare const onSubmitValidationRun: (shouldUseGetDisplayValue?: boolean | undefined) => (VariableStatement | import("typescript").IfStatement)[];
export declare const buildUpdateDatastoreQuery: (dataTypeName: string, recordName: string, relatedModelStatements: Statement[]) => (ExpressionStatement | VariableStatement)[];
/**
 *    const queryData = async () => {
 *    const record = id ? await DataStore.query(Tag, id) : tag;
 *    const linkedPosts = record
 *       ? await Promise.all(
 *           (
 *             await record.Posts.toArray()
 *           ).map((r) => {
 *             return r.post;
 *           }),
 *         )
 *       : [];
 *     setLinkedPosts(linkedPosts);
 *     setTagRecord(record);
 *   };
 *   queryData();
 */
export declare const buildUpdateDatastoreQueryForHasMany: (dataTypeName: string, recordName: string, hasManyFieldConfigs: [string, FieldConfigMetadata][]) => (ExpressionStatement | VariableStatement)[];
