import { FieldConfigMetadata } from '@aws-amplify/codegen-ui';
/**
 * This helper returns an evolving collection of artifacts produced by iterating through
 * the fieldConfigs object. Its purpose is to prevent iterating through this object
 * multiple times to shave off compute time.
 */
export declare function mapFromFieldConfigs(fieldConfigs: Record<string, FieldConfigMetadata>): {
    validationsObject: import("typescript").VariableStatement;
    dataTypesMap: {
        [dataType: string]: string[];
    };
    displayValueObject: import("typescript").VariableStatement | undefined;
    modelsToImport: string[];
    usesArrayField: boolean;
};
export declare const isManyToManyRelationship: (fieldConfigMetaData: FieldConfigMetadata) => string | false | undefined;
export declare const getHasManyFieldConfigs: (fieldConfigs: Record<string, FieldConfigMetadata>) => [string, FieldConfigMetadata][];
